/*
Copyright (c) 2004 Dmitry Markman, PhD dmarkman@mac.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "CC_DMWebKitView.h"
#include "org_dm_webkit_WebKitJava.h"

JavaVM *JVM = NULL;


// Simple JNI_OnLoad api
JNIEXPORT jint JNICALL JNI_OnLoad(JavaVM *vm, void *reserved)
{
    JVM = vm;
    return JNI_VERSION_1_4;
}

JNIEXPORT void JNICALL JNI_OnUnload(JavaVM *vm, void *reserved)
{
    printf("JNI_OnUnload\n");
}


/*
 * Class:     NSOpenGLView
 * Method:    createNSView
 * Signature: ()J
 */
JNIEXPORT jint JNICALL Java_org_dm_webkit_WebKitJava_createNSView1
  (JNIEnv *env, jobject nsWebKitViewView)
{
    CC_DMWebKitView *webKitView = nil;
    NS_DURING;
    // Here we create our custom NSView
    int initWidth = 200;
    int initHeight = 200;
    jclass clazz = env->FindClass(JRISigClass("org/dm/webkit/DMWebKitView"));
    if(clazz != 0){
        jfieldID fID = env->GetStaticFieldID(clazz,"INIT_WIDTH",JRISigInt);
        if(fID != 0){
            initWidth = env->GetStaticIntField(clazz,fID);
        }
        fID = env->GetStaticFieldID(clazz,"INIT_HEIGHT",JRISigInt);
        if(fID != 0){
            initHeight = env->GetStaticIntField(clazz,fID);
        }
    }
    webKitView = [[CC_DMWebKitView alloc] initWithFrame : NSMakeRect(0,0,initWidth,initHeight)];
    //fprintf(stderr,"OK : WebKitView\n");
    [webKitView setJVM : JVM];
    NS_HANDLER;
    fprintf(stderr,"ERROR : Failed to create WebKitView\n");
    NS_VALUERETURN(0, jlong);
    NS_ENDHANDLER;

    return (jint) webKitView;
}


